// 05.03.2006
// Compiler AVR-GCC 3.4.6
#ifndef ___SERIAL_H
#define ___SERIAL_H

#define F_CPU                 8000000      /* 8Mhz */
#define UART_BAUD_RATE_4800      4800      /* baudrate */
#define UART_BAUD_RATE_9600      9600      /* baudrate */
#define UART_BAUD_RATE_19200    19200      /* baudrate */

#define UART_BAUD_SELECT_4800 (F_CPU/(UART_BAUD_RATE_4800*16l)-1)
#define UART_BAUD_SELECT_9600 (F_CPU/(UART_BAUD_RATE_9600*16l)-1)
#define UART_BAUD_SELECT_19200 (F_CPU/(UART_BAUD_RATE_19200*16l)-1)

//WinAVR 3.4.3 setzt die Bitsetzbefehle sbi(),cbi() ins Assembler-Listing fr diese
//beiden #defines ein ! Also kein Grund Inline Assembler zu benutzen.
#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))
//#define sbi(portn, bitn) asm volatile("sbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))
//#define cbi(portn, bitn) asm volatile("cbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))

//Prototypes
extern void ser_init (void);
extern void ser_putc (unsigned char c);
extern void ser_puts (unsigned char *s);
extern int ser_gets (unsigned char *s, unsigned char len);
extern unsigned char ser_getc (void);
extern volatile unsigned char rcnt, rpos;
extern volatile unsigned char busy;

#endif
